/*
    Saundi 0.0.01 alpha by Markku Reunanen

    See COPYING for copyright info
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dmedia/audio.h>

#define BUFLEN 4096
#define ALBUFLEN 16384

int main(int argc,char *argv[])
{
    int     pc=0,n,rate=44100,chn=2,bytes=2,c=0;
    unsigned char   buf[BUFLEN];

    ALconfig    config;
    ALport      port;
    ALpv        value;

    for(n=1;n<argc;n++)
    {
        if(!strcmp(argv[n],"--help"))
        {
            puts("--help     This help");
            puts("--pc       Convert PC byte order (default:no)");
            puts("--mono     Play mono (default:stereo)");
            puts("--8        Play 8 bit (default:16)");
            puts("--rate xx  Ouput rate (default:44100)");
            return(EXIT_SUCCESS);
        }
        if(!strcmp(argv[n],"--pc"))
            pc=1;
        if(!strcmp(argv[n],"--mono"))
            chn=1;
        if(!strcmp(argv[n],"--8"))
            bytes=1;
        if(!strcmp(argv[n],"--rate"))
            rate=atoi(argv[n+1]);
    }

    if(!(config=alNewConfig()))
        return(EXIT_FAILURE);
    alSetWidth(config,(bytes==1)?AL_SAMPLE_8:AL_SAMPLE_16);
    alSetChannels(config,chn);
    alSetQueueSize(config,ALBUFLEN);
    alSetSampFmt(config,AL_SAMPFMT_TWOSCOMP);

    value.param=AL_RATE;
    value.value.i=rate;
    alSetParams(AL_DEFAULT_DEVICE,&value,1);

    if(!(port=alOpenPort("saundi","w",config)))
        return(EXIT_FAILURE);

    n=0;
    do
    {
        c=getchar();
        if(c!=EOF)
        {
            if(n==BUFLEN)
            {
                alWriteFrames(port,buf,n/bytes/chn);
                n=0;
            }
            if(bytes==1 || pc==0)
                buf[n]=c;
            else
                buf[n+1-(n&1)*2]=c;

            n++;
        }
        else
            alWriteFrames(port,buf,n/bytes/chn);

    } while(c!=EOF);

    alClosePort(port);
    alFreeConfig(config);

    return(EXIT_SUCCESS);
}
